# Text field

The text field element is used for many purposes, in this guide we will explain what features and settings it has and how to use it.

* [Features](#features) - _covers all of it's features_
* [Settings](#settings) - _covers all possible settings_


## Features

* [Auto Suggest](auto-suggest)
* [Special Validation](special-validation)
* [Conditional Validation](conditional-validation)
* [Distance & Duration Calculation](distance-duration-calculation)
* [Address Auto Complete](address-auto-complete)
* [Keyword Field](keyword-field)
* [Contact Entry Search](contact-entry-search)


## Settings

**General Settings:**
* [Unique Field Name](#unique-field-name)
* [Email Label](#email-label)
* [Field Label](#field-label)
* [Field Description](#field-description)
* [Placeholder](#placeholder)
* [Default Value](#default-value)
* [Tooltip Text](#tooltip-text)
* [Special Validation](#special-validation)
* [Conditional Validation](#conditional-validation)
* [Allow Field To Be Empty](#allow-field-to-be-empty)
* [Error Message](#error-message)

**Advanced Settings:**
* [Disable The Input Field](#disable-the-input-field)
* [Make Field Read-Only](#make-field-read-only)
* [Disable Autocompletion](#disable-autocompletion)
* [Individual / Grouped](#individual-grouped)
* [Masked Input](#masked-input)
* [Text To Uppercase](#text-to-uppercase)
* [Maximum Characters Allowed](#maximum-characters-allowed)
* [Minimum Characters Allowed](#minimum-characters-allowed)
* [Maximum Number Allowed](#maximum-number-allowed)
* [Minimum Number Allowed](#minimum-number-allowed)
* [Field Width](#field-width)
* [Wrapper Width](#wrapper-width)
* [Exclude From Email](#exclude-from-email)
* [Exclude From Contact Entry](#exclude-from-contact-entry)
* [Error Message Positioning](#error-message-positioning)
* [Custom TAB Index](#custom-tab-index)
* [Custom Field Class](#custom-field-class)
* [Custom Wrapper Class](#custom-wrapper-class)

**Icon Settings:**
_This feature is covered under the guide [Icons](icons)_
* [Icon Positioning](#icon-positioning)
* [Icon Alignment](#icon-alignment)
* [Icon](#icon)

**Conditional Logic:**
_This feature is covered under the guide [Conditional Logic](conditional-logic)_